<template>
    <div class="text-center">
        <v-dialog v-model="dialog" width="500" v-if="isCurrentUserAllowed" ref="dialog">
            <template v-slot:activator="{ on, attrs }">
                <v-btn v-if="!isAdd" v-bind="attrs" v-on="on" outlined color="green" elevation="5"
                       class="ml-1 mr-1 white--text"
                       @click="setLesson">
                    {{ $t("LNG_LESSON_EDIT") }}
                </v-btn>

                <v-btn v-else
                       style="background-color: #0ABBEF; color: white"
                       v-bind="attrs" v-on="on"
                       @click="addLesson">
                    <v-icon>mdi-plus</v-icon>
                    {{ $t("LNG_LESSON_ADD") }}
                </v-btn>
            </template>
            <v-card>
                <v-card-title class="headline blue">
                    <span class="headline white--text">
                        {{ (isAdd) ? $t('LNG_LESSON_ADDLESSON') : $t('LNG_LESSON_EDITLESSON') }}
                    </span>
                    <v-spacer></v-spacer>
                    <v-btn color="error" fab small @click="cancel">
                        <v-icon color="white">mdi-close</v-icon>
                    </v-btn>
                </v-card-title>
                <v-card-text>
                    <v-form ref="form" class="px-3">
                        <v-row no-gutters class="mt-3">
                            <v-col cols="12">
                                <v-text-field
                                    v-model="lessonName"
                                    :label="$t('LNG_LESSON_TITLE')"
                                    :rules="[v => !!v || $t('LNG_LESSON_MANDATORY')]"
                                    required
                                    color="#0BBBEF"
                                    clearable
                                />
                            </v-col>
                            <v-col cols="12">
                                <v-switch
                                    v-model="hide"
                                    :label="$t('LNG_LESSON_HIDE')"
                                ></v-switch>
                            </v-col>
                            <v-col cols="12">
                                <v-row no-gutters>
                                    <v-col cols="12" md="6">
                                        <v-menu
                                            v-model="menuDateStart"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="250px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="dateStart"
                                                              :label="$t('LNG_LESSON_DATESTART')"
                                                              prepend-icon="mdi-calendar"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateBeginning"
                                                ></v-text-field>
                                            </template>
                                            <v-date-picker
                                                v-model="dateStart"
                                                @input="menuDateStart = false"
                                                @change="updateBeginning"
                                            ></v-date-picker>
                                        </v-menu>
                                        <v-menu
                                            v-model="menuTimeStart"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="290px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="timeStart"
                                                              :label="$t('LNG_LESSON_TIMESTART')"
                                                              prepend-icon="mdi-clock-time-four-outline"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateBeginning"
                                                ></v-text-field>
                                            </template>
                                            <v-time-picker
                                                format="24hr"
                                                srollable
                                                v-if="menuTimeStart"
                                                v-model="timeStart"
                                                @input="menuTimeStart = false"
                                                @change="updateBeginning"
                                                full-width
                                            ></v-time-picker>
                                        </v-menu>
                                    </v-col>
                                    <v-col cols="12" md="6">
                                        <v-menu
                                            v-model="menuDateEnd"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="250px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="dateEnd"
                                                              :label="$t('LNG_LESSON_DATEEND')"
                                                              prepend-icon="mdi-calendar"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateEnding"
                                                ></v-text-field>
                                            </template>
                                            <v-date-picker
                                                v-model="dateEnd"
                                                @input="[menuDateEnd = false]"
                                                @change="updateEnding"
                                            ></v-date-picker>
                                        </v-menu>
                                        <v-menu
                                            v-model="menuTimeEnd"
                                            :close-on-content-click="false"
                                            :nudge-right="-20"
                                            :nudge-top="-30"
                                            transition="scale-transition"
                                            offset-y
                                            top
                                            min-width="290px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field class="mr-4"
                                                              v-model="timeEnd"
                                                              :label="$t('LNG_LESSON_TIMEEND')"
                                                              prepend-icon="mdi-clock-time-four-outline"
                                                              v-bind="attrs"
                                                              v-on="on"
                                                              @change="updateEnding"
                                                ></v-text-field>
                                            </template>
                                            <v-time-picker
                                                format="24hr"
                                                srollable
                                                v-if="menuTimeEnd"
                                                v-model="timeEnd"
                                                @input="menuTimeEnd = false"
                                                @change="updateEnding"
                                                full-width
                                            ></v-time-picker>
                                        </v-menu>
                                    </v-col>
                                    <v-col cols="12" v-if="isBegAfterEnd">
                                        <p style="color: #ff0000">{{ $t('LNG_LESSON_BEGAFTEREND') }}</p>
                                    </v-col>
                                    <v-col cols="12" v-if="!datesFilled">
                                        <p style="color: #ff0000">{{ $t('LNG_LESSON_WORKFORMINCORRECT') }}</p>
                                    </v-col>

                                </v-row>
                            </v-col>
                            <v-col cols="12" class="text-center mt-4">
                                <v-btn color="error" class="mr-4" @click="cancel">
                                    {{ $t('LNG_LESSON_CANCEL') }}
                                </v-btn>
                                <v-btn :disabled="!valid" color="success" class="mr-4" @click="submit">
                                    {{ $t('LNG_LESSON_VALIDATE') }}
                                </v-btn>
                            </v-col>
                            <v-col cols="12" class="text-center mt-2">
                                <p v-if="requestOK || requestFail"
                                   :style="{ color: (requestOK) ? '#0ABBEF' : '#ff0000'}"
                                   class="mb-n2">
                                    {{ message }}
                                </p>
                            </v-col>
                        </v-row>
                    </v-form>
                </v-card-text>
            </v-card>
        </v-dialog>
    </div>
</template>

<script>
import Services from "@/services/api/index"
import { SET_LESSONS } from "@/store/mutations.type";
import dayjs from 'dayjs';
import { mapGetters } from "vuex";

export default {
    name: 'LessonEdit',
    props: {
        isAdd: Boolean,
    },
    data: () => ({
        dialog: false,
        valid: true,
        lessonId: -1,
        lessonName: "",
        hide: false,
        menuDateStart: false,
        menuDateEnd: false,
        menuTimeStart: false,
        menuTimeEnd: false,
        dateStart: "",
        dateEnd: "",
        timeStart: "",
        timeEnd: "",
        beginning: null,
        ending: null,
        datesFilled: false,
        isBegAfterEnd: false,
        requestOK: false,
        requestFail: false,
        message: ""
    }),
    computed: {
        ...mapGetters([
            'user',
            'currentLessonId',
            'lessons'
        ]),
        isCurrentUserAllowed() {
            return this.user && (this.user.type === 'TEACHER' || this.user.type === 'ADMIN');
        }
    },
    watch: {
        dialog: function (dialog) {
            if (!dialog) {
                this.cancel();
            }
        }
    },
    methods: {
        addLesson() {
            this.beginning = dayjs();
            this.dateStart = this.beginning.format("YYYY-MM-DD");
            this.timeStart = this.beginning.format("HH:mm");
            this.datesFilled = true;
        },
        // Fill in the form fields when the user clicks on the edit button
        setLesson() {
            const currentLesson = this.lessons[this.currentLessonId];

            this.lessonId = currentLesson.id;
            this.lessonName = currentLesson.title;
            this.hide = currentLesson.hide;
            this.beginning = currentLesson.beginning;
            this.ending = currentLesson.ending;

            const start = (this.beginning === null) ? null : dayjs(new Date(this.beginning));
            const end = (this.ending === null) ? null : dayjs(new Date(this.ending));

            if (start) {
                this.dateStart = start.format("YYYY-MM-DD");
                this.timeStart = start.format("HH:mm");
            }
            if (end) {
                this.dateEnd = end.format("YYYY-MM-DD");
                this.timeEnd = end.format("HH:mm");
            }
            this.datesFilled = true;
        },
        // Each times the beginning or ending dates are modified (day with hours) -> check if the chosen dates are valid
        updateBeginning() {
            if (this.dateStart && this.timeStart) {
                this.beginning = dayjs(this.dateStart + '/' + this.timeStart, 'YYYY-MM-DD/HH:mm');
                if (this.ending !== null) {
                    this.isBegAfterEnd = this.beginning > this.ending;
                }
            }
            this.datesFilled = !((this.dateStart && !this.timeStart) || (!this.dateStart && this.timeStart) ||
                (this.dateEnd && !this.timeEnd) || (!this.dateEnd && this.timeEnd));
        },
        updateEnding() {
            if (this.dateEnd && this.timeEnd) {
                this.ending = dayjs(this.dateEnd + '/' + this.timeEnd, 'YYYY-MM-DD/HH:mm');
                if (this.beginning !== null) {
                    this.isBegAfterEnd = this.beginning > this.ending;
                }
            }
            this.datesFilled = !((this.dateStart && !this.timeStart) || (!this.dateStart && this.timeStart) ||
                (this.dateEnd && !this.timeEnd) || (!this.dateEnd && this.timeEnd));
        },
        async submit() {
            if (this.$refs.form.validate()) {
                // If form isn't well completed -> do nothing
                if (!this.datesFilled || this.isBegAfterEnd) {
                    return;
                }

                let data = {
                    title: this.lessonName,
                    hide: this.hide,
                    beginning: this.beginning?.valueOf(),
                    ending: this.ending?.valueOf(),
                }


                if (this.isAdd) {
                    // Adding the field id using the stored current route's data
                    data.field_id = this.$route.params.id;
                    data.order = this.lessons.length;
                    Services.Lesson.postLesson(data)
                        .then(async (res) => {
                            // Manage returned HTTP code
                            this.manageHTTPCodeReturned(res.status);
                            // Update store if the POST worked
                            if (res.status === 201) {
                                const lessons = await Services.Lesson.getLessonByField(data.field_id);
                                this.$store.commit(SET_LESSONS, lessons);
                            }
                        })
                } else {
                    data.id = this.lessonId;
                    Services.Lesson.patchLesson(data)
                        .then(async (res) => {
                            // Manage returned HTTP code
                            this.manageHTTPCodeReturned(res.status);
                            // Update store if the PATCH worked
                            if (res.status === 200) {
                                const lessons = await Services.Lesson.getLessonByField(this.$route.params.id);
                                this.$store.commit(SET_LESSONS, lessons);
                            }
                        });
                }
            }
        },
        // Display a message for the user with the returned HTTP code
        manageHTTPCodeReturned(code) {
            this.requestOK = false;
            this.requestFail = false;
            switch (code) {
                case 200:
                    this.requestOK = true;
                    this.message = this.$t("LNG_LESSON_UPDATED");
                    setTimeout(() => {
                        this.cancel();
                    }, 1000);
                    break;
                case 201:
                    this.requestOK = true;
                    this.message = this.$t("LNG_LESSON_ADDED");
                    setTimeout(() => {
                        this.cancel();
                    }, 1000);
                    break;
                case 400:
                    this.requestFail = true;
                    this.message = this.$t("LNG_LESSON_ERROR400") + " Code : " + code;
                    break;
                case 404:
                    this.$router.push('404 Not found');
                    break;
                default:
                    if (code >= 400 && code < 500) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_CLIENTERROR") + " Code : " + code;
                    } else if (code >= 500 && code < 600) {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_SERVERERROR") + " Code : " + code;
                    } else {
                        this.requestFail = true;
                        this.message = this.$t("LNG_LESSON_FAILED") + " Code : " + code;
                    }
            }
        },
        cancel() {
            this.$refs.form.reset();
            this.requestOK = false;
            this.requestFail = false;
            this.dialog = false;
        }
    }
}

</script>